@use './styles/form-file-upload.variations' as variations;
@use './styles/form-file-upload.variables' as *;
@use '../../../global/styles/styles-variables' as *;
@use '../../../global/styles/utilities' as *;

:host {
	@include digi-form-file-upload--variables;
	$base: '.digi-form-file-upload';
	container-type: inline-size;
	display: block;
	width: 100%;

	a {
		font-weight: var(--digi--global--typography--font-weight--semibold);
		color: var(--digi--color--text--link);
	}

	.digi-form-file-upload {
		&--small {
			@include variations.small;
		}

		&--medium {
			@include variations.medium;
		}

		&--large {
			@include variations.large;
		}

		&__spinner {
			margin-right: 0.5rem;
			animation: animation__rotation .5s * 6 infinite linear;
			transform-origin: center;
			--digi--icon--height: #{rem(16)};

			@media (prefers-reduced-motion) {
				animation: none;
			}

			@keyframes animation__rotation {

				from {
					transform: rotate(0deg);
				}

				to {
					transform: rotate(359deg);
				}
			}
		}

		&__input {
			display: none;
		}

		&__button {
			margin: 0 0 auto auto;
			text-align: center;
			white-space: nowrap;
			background: none;
			border: none;
			cursor: pointer;
			font-weight: var(--digi--typography--button--font-weight--desktop);
			font-size: var(--digi--typography--body--font-size--desktop);
			color: var(--digi--form-file-upload--button-text--color--default);
			display: flex;
			align-items: center;
			font-family: var(--digi--global--typography--font-family--default);

			&:hover {
				color: var(--digi--form-file-upload--button-text--color--hover);

				 .digi-form-file-upload__button-icon {
				 	--digi--icon--color: var(--digi--form-file-upload--button-text--color--hover);
				 }
			}
			&-icon {
				width: 20px !important;
				height: 20px !important; 
				margin-left: 5px;
				--digi--icon--color: var(--digi--color--icons--complementary-1);
				padding: var(--ICON--PADDING);
				padding-left: 0;
				&:hover {
					--digi--icon--color: var(--digi--form-file-upload--button-text--color--hover);
			}
		}

		}
		.digi-form-file-upload__button--mobile {
			@container (min-width: 501px){
				display: none;
			}
		}

		&__upload-area {
			border-color: var(--COLOR--BORDER--DEFAULT);
			border-radius: var(--BORDER-RADIUS--DEFAULT);
			border-width: var(--BORDER-WIDTH--DEFAULT);
			border-style: var(--BORDER-STYLE--DEFAULT);
			max-width: var(--WIDTH);
			margin: 0;
			display: flex;
			flex-direction: column;
			background-color: var(--COLOR--BACKGROUND--DEFAULT);
			align-items: center;
			padding: var(--PADDING);
			margin-bottom: var(--digi--gutter--medium);
			position: relative;
			cursor: pointer;

			&--hover {
				border-color: var(--COLOR--BORDER--HOVER);
			}

			&-overlay {
				position: absolute;
				width: 100%;
				height: 100%;
				background-color: var(--COLOR--BACKGROUND--HOVER);
				opacity: .1;
				top: 0;
				left: 0;
				z-index: 10;
			}
		}

		&__text-area {
			display: flex;
			flex-direction: column;
			align-items: center;
			justify-content: center;
			text-align: center;
		}

		&__text {
			display: flex;
			flex-direction: column;
			align-items: center;
			text-align: center;
		}

		&__files {
			border-radius: var(--BORDER-RADIUS--DEFAULT);
			max-width: 100%;
			background-color: var(--COLOR--BACKGROUND--DEFAULT);
			padding: var(--digi--gutter--largest-2) var(--digi--padding--large);
			margin-bottom: var(--digi--gutter--medium);
			margin-top: var(--digi--gutter--medium);
			padding-bottom: var(--digi--padding--smaller);

			ul {
				max-width: none;
				padding: 0;
				margin: 0;
			}

			h4 {
				margin: 0;
				padding: 0;
				font-weight: var(--digi--typography--body--font-weight--desktop);
			}
		}

		&__files-heading {
			font-family: var(--digi--form-file-upload--heading--font-family);
			font-size: var(--digi--typography--label--font-size--desktop);
			font-weight: var(--digi--form-file-upload--heading--font-weight);
			color: var(--digi--color--text--primary);
			margin: var(--digi--margin--smaller) 0 0 0;
			display: block;

			// @media (min-width: $digi--breakpoint--large) {
			// 	font-size: var(--digi--form-file-upload--heading--font-size--large);
			// }
		}

		&__item {
			margin: var(--digi--margin--small) 0;

			&-container {
				list-style-type: none;

				&:nth-child(n+2) {
					border-top: var(--BORDER-WIDTH--DEFAULT) solid var(--digi--color--border--neutral-2);
				}
			}

			&-header {
				display: flex;
				align-items: center;

				span {
					margin: 0 auto 0 0;
				}
			}

			&-footer {
				padding-left: 30px;
			}

			&-name {
				margin: auto 0 auto var(--digi--margin--large) !important;
				//overflow: hidden;
				text-overflow: ellipsis;
				font-weight: var(--digi--typography--button--font-weight--desktop);
				font-size: var(--digi--typography--body--font-size--desktop);
				white-space: nowrap;
				height: max-content;
				&-pending{
					margin: auto 0 auto var(--digi--margin--large) !important;
					text-overflow: ellipsis;
					font-weight: var(--digi--form-file-upload--font-weight);
					font-size: var(--digi--typography--body--font-size--desktop);
					white-space: nowrap;
					height: max-content;
				}

				&--thumbnail {
					font-weight: var(--digi--typography--button--font-weight--desktop);
					font-size: var(--digi--typography--body--font-size--desktop);
					margin: auto 0 auto var(--digi--margin--small);
					color: var(--digi--form-file-upload--button-text--color--default);
				}

				&--preview {
					&::before {
						position: absolute;
						content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' %3E%3Cg fill='none' fill-rule='evenodd'%3E%3Ccircle fill='%23FFF' cx='8' cy='8' r='6'/%3E%3Cpath d='M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0Zm-8.925 4.236L13.01 6.3a.516.516 0 0 0 0-.73l-.73-.73a.516.516 0 0 0-.73 0L6.71 9.682l-2.26-2.26a.516.516 0 0 0-.73 0l-.73.73a.516.516 0 0 0 0 .73l3.355 3.355a.516.516 0 0 0 .73 0Z' fill='%23009322'/%3E%3C/g%3E%3C/svg%3E");
						top: 4px;
						left: 0px;
						width: 18px;
						height: 18px;
						overflow: hidden;
					}
				}

				@media (max-width: 500px) {
					max-width: 17.5rem;
				}
			}
			.digi-form-file-upload__item-name{
				@container(max-width: 500px){
					max-width: 17.5rem;
				}
			}

			&-text-container {
				position: relative;
				display: flex;
				padding: 0;
				margin: 0;
				justify-content: space-between;

				&-inner {
					display: flex;
				}

				&-figure {
					margin: 0;

					&::after {
						position: absolute;
						content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' %3E%3Cg fill='none' fill-rule='evenodd'%3E%3Ccircle fill='%23FFF' cx='8' cy='8' r='6'/%3E%3Cpath d='M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0Zm-8.925 4.236L13.01 6.3a.516.516 0 0 0 0-.73l-.73-.73a.516.516 0 0 0-.73 0L6.71 9.682l-2.26-2.26a.516.516 0 0 0-.73 0l-.73.73a.516.516 0 0 0 0 .73l3.355 3.355a.516.516 0 0 0 .73 0Z' fill='%23009322'/%3E%3C/g%3E%3C/svg%3E");
						top: -6px;
						left: 24px;
						width: 18px;
						height: 18px;
						overflow: hidden;
					}
				}

				.thumbnail {
					width: rem(32);
					height: rem(32);
					object-fit: cover;
					flex-grow: 0;
				}

				.hidden {
					margin-left: var(--digi--margin--larger);
				}
			}

			&-pdf-preview {
				position: relative;
				top: 8px;
				left: 5px;
				//margin-right: 20px;

				&::after {
					position: absolute;
					content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' %3E%3Cg fill='none' fill-rule='evenodd'%3E%3Ccircle fill='%23FFF' cx='8' cy='8' r='6'/%3E%3Cpath d='M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0Zm-8.925 4.236L13.01 6.3a.516.516 0 0 0 0-.73l-.73-.73a.516.516 0 0 0-.73 0L6.71 9.682l-2.26-2.26a.516.516 0 0 0-.73 0l-.73.73a.516.516 0 0 0 0 .73l3.355 3.355a.516.516 0 0 0 .73 0Z' fill='%23009322'/%3E%3C/g%3E%3C/svg%3E");
					top: -21px;
					left: 15px;
					width: 18px;
					height: 18px;
					overflow: hidden;
				}
			}
			&-pdf-preview-bis {
				position: relative;
				top: 8px;
				left: 5px;
				//margin-right: 20px;

				&::after {
					position: absolute;
					content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' %3E%3Cg fill='none' fill-rule='evenodd'%3E%3Ccircle fill='%23FFF' cx='8' cy='8' r='6'/%3E%3Cpath d='M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0Zm-8.925 4.236L13.01 6.3a.516.516 0 0 0 0-.73l-.73-.73a.516.516 0 0 0-.73 0L6.71 9.682l-2.26-2.26a.516.516 0 0 0-.73 0l-.73.73a.516.516 0 0 0 0 .73l3.355 3.355a.516.516 0 0 0 .73 0Z' fill='%23009322'/%3E%3C/g%3E%3C/svg%3E");
					top: -7px;
					left: 15px;
					width: 18px;
					height: 18px;
					overflow: hidden;
				}
			}

			&-info {
				width: 100%;
			}

			span {
				@media (max-width: 500px) {
					margin-left: 0;
					margin-right: auto;
				}
			}
			.digi-form-file-upload__item{
				span {
				@container (max-width: 500px) {
					margin-left: 0;
					margin-right: auto;
				}
			}
		}

			&-button {
				margin-left: auto;
				font-weight: var(--digi--global--typography--font-weight--semibold);
			}

			&--error {
				display: flex;
				color: var(--digi--color--text--danger);

				@media (max-width: 500px) {
					span {
						display: none;
					}
				}
			}
			.digi-form-file-upload__item--error{
				span {
				@container (max-width: 500px) {
					display: none;
					}
				}
			}
		}

		&__error {
			color: var(--digi--color--icons--danger);
		}
	}

	.visually-hidden {
		@include digi--a11y--sr-only;
	}
	
	.hidden-mobile {
		@media (max-width: 500px) {
			display: none;
		}
	}
	
	.digi-form-file-upload .hidden-mobile {
		@container (max-width: 500px) {
			display: none;
		}
	}

	.check-green-opac {
		&::before {
			content: url("data:image/svg+xml,%3Cg fill='none' fill-rule='evenodd'%3E%3Ccircle fill='%23FFF' cx='8' cy='8' r='6'/%3E%3Cpath d='M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0Zm-8.925 4.236L13.01 6.3a.516.516 0 0 0 0-.73l-.73-.73a.516.516 0 0 0-.73 0L6.71 9.682l-2.26-2.26a.516.516 0 0 0-.73 0l-.73.73a.516.516 0 0 0 0 .73l3.355 3.355a.516.516 0 0 0 .73 0Z' fill='%23009322'/%3E%3C/g%3E4");
			transform: scale(1.2);
			position: absolute;
			display: inline-block;
			z-index: 1;
			left: 6rem;
			top: 2rem;
		}
	}
}